#!/usr/bin/php -q
<?php

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
        die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

include(dirname(__FILE__)."/include/config.php");
include_once($config["base_path"]."/lib/data_query.php");
include_once("data_input_function.php");


function usage()
{
?>
Usage: data_input_cmd.php --type [method|input|output] --do [add|edit|delete|show]  [type-options]

For --type method: 
    For --do add:
		--name [name] *unqe name
    	--inputType [2 - snmp]
                  [3 - scriptcommand]
                  [1 - snmpquery]
                  [4 - scriptquery]
                  [5 - scriptserver]
                  [6 - scriptqueryserver]
    	--inputString [input fields with script path] 
	For --edit:
    	--ID [id number of record]
		&& arguments from add
    For --delete:
    	--ID [id number of record]
	For --show:
		--ID [id number of record] *for selected record
    
For --type input: 
	For --do add:
		--name [name] -unqe name
    	--methodID [ID number of method] *node of method parent
    	--dataName [FriendlyName] *friendly name
    	--typeCode snmp_timeout  *snmp time out
    	--regexpMatch [*.] *regular match
	For --edit:
    	--ID [id number of record]
    	&& arguments from add
    For --delete:
    	--ID [id number of record]
	For --show:
        --ID [id number of record] *for selected record

For --type output:
	For --do add:
		--name [name] *unqe name
		--methodID [ID number of method] *node of method parent
		--dataName [FriendlyName] *friendly name 
		--updateRRA *for auto update RRA file
	For --edit:
		--ID [id number of record] *for selected record
		&& arguments from add
    For --delete:
    	--ID [id number of record]
	For --show:
        --ID [id number of record] *for selected record

<?php
}

global $throwExceptionArray;
$throwExceptionArray = array();

if ($_SERVER["argc"] == 1)
{
    usage();
    return(1);
}
else
{

    $type      = ''; # Data Input Methods, Input Fields or Output Fields
    $do 	   = ''; # Edit record, delete, show records
    $id        =  0; # For selected record
    $name      = '';
    # Name - Enter a meaningful name for this data input method.
    # Field [Output] - Enter a name for this Output field.

    $inputString  = '';  # The data that is sent to the script, which includes the complete path to the script and input sources in <> brackets.
    $inputType = ''; #Choose what type of data input method this is.
    $dataName = '';
    # Field [Output] - Enter a name for this Output field.
    $updateRRA = false;
    # Update RRD File - Whether data from this output field is to be entered into the rrd file.
    $allowNulls = false;
    #Allow Empty Input - Check here if you want to allow NULL input in this field from the user.
    $methodID  = 0; # ID of method
    $typeCode  = '';
    $regexpMatch = '';

    for ($i = 1; $i < $_SERVER["argc"]; $i++)
    {
        switch($_SERVER["argv"][$i])
        {
            case "--type":
                $i++;
                $type = $_SERVER["argv"][$i];
                break;
            case "--do":
                $i++;
                $do = $_SERVER["argv"][$i];
                break;
            case "--ID":
                $i++;
                $id = $_SERVER["argv"][$i];
                break;
            case "--name":
                $i++;
                $name = $_SERVER["argv"][$i];
                break;
            case "--inputString":
                $i++;
                $inputString = $_SERVER["argv"][$i];
                break;
            case "--inputType":
                $i++;
                $inputType = $_SERVER["argv"][$i];
                break;
            case "--dataName":
            	$i++;
            	$dataName = $_SERVER["argv"][$i];
                break;
            case "--updateRRA":
                $updateRRA = true;
                break;
            case "--allowNulls":
                $allowNulls = true;
                break;
            case "--methodID":
                $i++;
                $methodID = $_SERVER["argv"][$i];
                break;
            case "--typeCode":
                $i++;
                $typeCode = $_SERVER["argv"][$i];
                break;
            case "--regexpMatch":
            	$i++;
            	$regexpMatch = $_SERVER["argv"][$i];
                break;
            default:
                usage();
                return 0;
        }
    }

    
    
    if ($type == 'method')
    {
	    if ($do == 'show')
	    {
		    # php data_input_cmd.php --type method --do show
		    # php data_input_cmd.php --type method --do show --ID 12

		    $tmpArray = method_show($id);
            echo "Methods: \n(id, \tname, \tinput_string)\n";
      	    foreach ($tmpArray as $field){
      	    	echo $field["id"] . "\t" . $field["name"] . "\t" . $field["input_string"] . "\n";
      	    }
            return 0;
		}elseif ($do == 'add'){
			# php data_input_cmd.php --type method --do add --name TestMethod --inputType scriptcommand --inputString c:/phptest/random2.pl
			$data_input_id = method_add($name, $inputString, $inputType);
    
			if ($throwExceptionArray){printThrowException();cleanException();return 1;}
            
            printf("Method Created - method-id: (%s)\n", $data_input_id);
            return 0;
    	}elseif ($do == 'edit'){
            # php data_input_cmd.php --type method --do edit --ID 16 --name TestMethod --inputType scriptcommand --inputString c:/phptest/random2.pl
            $data_input_id = method_edit($id, $name, $inputString, $inputType);
    		if ($throwExceptionArray){printThrowException();cleanException();return 1;}

            printf("Method Edited - method-id: (%s)\n", $data_input_id);
            return 0;
		}elseif ($do == 'delete'){
            # php data_input_cmd.php --type method --do delete --ID 16
            $data_input_id = method_delete($id);
            if ($throwExceptionArray){printThrowException();cleanException();return 1;}
            
            printf("Method Deleted - method-id: (%s)\n", $data_input_id);
            return 0;
		 }else{usage(); return 0;}
    }
    elseif ($type == 'input')
    {
    	if ($do == 'show') 
	    {
        	# php data_input_cmd.php --type input --do show
		    # php data_input_cmd.php --type input --do show  --ID 40
		    # php data_input_cmd.php --type input --do show  --methodID 13
    		$tmpArray = input_show($id,$methodID);
    		echo "Methods: \n(id, \tname \tmethodID, \tdataName, \ttypeCode, \tregexpMatch)\n";
            foreach ($tmpArray as $field){
              	echo $field["id"] . "\t" . $field["name"] . "\t" . $field["data_input_id"] . "\t" . $field["data_name"] . "\t" . $field["type_code"]. "\t" . $field["regexp_match"] .  "\t" . $field["allow_nulls"] . "\n";
            }
		    return 0;
		}elseif ($do == 'add'){
		  	# php data_input_cmd.php --type input --do add --name InputField --methodID 16 --dataName friendlyNameIN --typeCode snmp_timeout --regexpMatch hksdf --allowNulls
		  	$data_input_field_id = input_add($methodID, $name, $dataName, $typeCode, $regexpMatch, $allowNulls);
			if ($throwExceptionArray){printThrowException();cleanException();return 1;}
			
			printf("Input Created - input-id: (%d)\n", $data_input_field_id);
			return 0;
		}elseif ($do == 'edit'){
		  	# php data_input_cmd.php --type input --do edit --ID 41  --name InputField1 --methodID 16 --dataName friendlyNameIN --typeCode snmp_timeout --regexpMatch hksdf
		  	$data_input_field_id = input_edit($id, $methodID, $name, $dataName, $typeCode, $regexpMatch, $allowNulls);
			if ($throwExceptionArray){printThrowException();cleanException();return 1;}
			
			printf("Input Edited - input-id: (%d)\n", $data_input_field_id);
			return 0;
		}elseif ($do == 'delete'){
      		# php data_input_cmd.php --type input --do delete --ID 41
      		$data_input_field_id = input_delete($id);
			if ($throwExceptionArray){printThrowException();cleanException();return 1;}
			
			printf("Input Deleted - input-id: (%d)\n", $data_input_field_id);
			return 0;
		}else{usage(); return 0;}
    }
    elseif ($type == 'output')
    {
	    if ($do == 'show')
	    {
        	# php data_input_cmd.php --type output --do show
		    # php data_input_cmd.php --type output --do show  --ID 40
		    # php data_input_cmd.php --type output --do show  --methodID 4
		    
		    $tmpArray = output_show($id,$methodID);
			echo "Methods: \n(id, \tname, \tmethodID, \tdataName, \tupdateRRA)\n";
        	foreach ($tmpArray as $field){
          		echo $field["id"] . "\t" . $field["name"] . "\t" . $field["data_input_id"] . "\t" . $field["data_name"] . "\t" . $field["update_rra"]."\n";
        	}
		    return 0;
      	}elseif ($do == 'add') {
        	# php data_input_cmd.php --type output --do add --name OutputField --methodID 30 --dataName friendlyName --updateRRA
        	$data_input_field_id = output_add($methodID, $name, $dataName,  $updateRRA);
        	if ($throwExceptionArray){printThrowException();cleanException();return 1;}

        	printf("Output Created - output-id: (%d)\n", $data_input_field_id);
        	return 0;
      	}elseif ($do == 'edit'){
        	# php data_input_cmd.php --type output --do edit --name OutputField --methodID 30 --dataName friendlyName --updateRRA
        	$data_input_field_id = output_edit($id, $methodID, $name, $dataName,  $updateRRA);
        	if ($throwExceptionArray){printThrowException();cleanException();return 1;}
        	
        	printf("Output Edited - output-id: (%d)\n", $data_input_field_id);
        	return 0;
		}elseif ($do == 'delete'){
		    # php data_input_cmd.php --type output --do delete --ID 41
		    $data_input_field_id = output_delete($id);
        	if ($throwExceptionArray){printThrowException();cleanException();return 1;}
        	
        	printf("Output Deleted - output-id: (%d)\n", $data_input_field_id);
        	return 0;
		}else{usage(); return 0;}
    }else{usage(); return 0;}
}

function printThrowException(){
	global $throwExceptionArray;
  	foreach($throwExceptionArray as  $throwException){
  		printf ("Error: " . $throwException["description"] . ".\n");
  	}
}

?>