<?php
include_once("error_Exception.php");
include_once("data_input_validate.php");

######################################################################################################
/*
 * For method
 */
function method_show($id) {
	if (empty($id) || $id == 0){$wherequery = "";} else {$wherequery = " where id = $id ";}
	$returnResult = db_fetch_assoc("select id, name, input_string from data_input $wherequery order by id");
	return $returnResult;
}

function method_add($name, $inputString, $inputType) {
	global $throwExceptionArray;
	
  	//Input data validation
  	$data_input = validateMethodFields(0, $name, $inputString, $inputType);
	if(!empty($throwExceptionArray)){return;}
	
	//DataBase validation
	$existAlready = db_fetch_cell("select id from data_input where name = '$name'");
	if(isset($existAlready)){
		catchException($name,"name","method_add","Already exists - name: " . $name);
        return;
  	}

  	//DataBase execute
	$data_input_id = sql_save($data_input, "data_input");
	return $data_input_id;
}

function method_edit($id, $name, $inputString, $inputType) {
	global $throwExceptionArray;
	
	//Input data validation
    if (empty($id) || $id == 0) {
        catchException($id,"id","method_edit","Id must not be empty or zero!");
        return;
    }
    $data_input = validateMethodFields($id, $name, $inputString, $inputType);
    if(!empty($throwExceptionArray)){return;}
  
    //DataBase validation
    $existAlready = db_fetch_cell("select id from data_input where id = $id");
    if(!isset($existAlready)){
    	catchException($id,"id","method_edit","Not exists - id: " . $id);
    	return;
    }
  
    //DataBase execute
    $data_input_id = sql_save($data_input, "data_input");
    return $data_input_id;
}

function method_delete($id) {
    //Input data validation
    if (empty($id) || $id == 0) {
    	catchException($id,"id","method_delete","Id must not be empty or zero!");
    	return;
    }
    //DataBase validation
    /*$existAlready = db_fetch_cell("select id from data_input where id = '$id'");
    if(!isset($existAlready)){
    $returnResult = throwException($id,"id","method_delete","Not exists - id: " . $id);
    return $returnResult;
    }*/
  
    //DataBase execute
    $data_input_fields = db_fetch_assoc("select id from data_input_fields where data_input_id=" . $id);
    
    if (is_array($data_input_fields)) {
    	foreach ($data_input_fields as $data_input_field) {
    		db_execute("delete from data_input_data where data_input_field_id=" . $data_input_field["id"]);
    	}
    }

	db_execute("delete from data_input where id=" . $id);
	db_execute("delete from data_input_fields where data_input_id=" . $id);

	return  $id;
}

######################################################################################################
/*
 * For input
 */
function input_show($id,$methodID) {
	if (!empty($id) || $id != 0){
		$wherequery = "where id = $id and input_output = 'in'";
	} elseif(!empty($methodID) || $methodID != 0) {
		$wherequery = "where data_input_id = $methodID and input_output = 'in'";
	} else {
		$wherequery = "where input_output = 'in'";
	}
	
  	$returnResult = db_fetch_assoc("select id, name, data_input_id, data_name, type_code, regexp_match, allow_nulls from data_input_fields $wherequery order by id");
  	return $returnResult;
}

function input_add($methodID, $name, $dataName, $typeCode, $regexpMatch, $allowNulls) {
	global $throwExceptionArray;
	
	//Input data validation 	
	$data_input_fields = validateInputOutputFields(0, "input", $methodID, $name, $dataName,  "", $typeCode, $regexpMatch, $allowNulls);
	
	if ($throwExceptionArray){return;}

    //DataBase validation
	$typeID = db_fetch_cell("select type_id from data_input where id = " . $methodID);
	if (!$typeID) {
    	catchException($methodID,"methodID","input_add","Not exists - id: " . $methodID);
      	return;
    }
	
    if ($typeID == 1){
		$substring = db_fetch_cell("select input_string from data_input where id = " . $methodID); 	//select script with input and output parameters
		$returnval = checkAvalibleInputOutputFields($substring);
		if (!isset($returnval)){
        	catchException($returnval,"returnval","input_add","This script appears to have no input values, therefore there is nothing to add");
        	return;
      	}
	}
  
	/*$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'in' and name = '$name'");
	if(isset($existAlready)){
	$returnResult = throwException($name,"name","input_add","Exists - name: " . $name);
	return $returnResult;
	}*/

	//DataBase execute
	$data_input_field_id = sql_save($data_input_fields, "data_input_fields");
	
	db_execute("update data_input_fields set sequence=0 where data_input_id=" . $methodID);
	$input_string = db_fetch_cell("select input_string from data_input where id = '" . $methodID . "'");
	generate_data_input_field_sequences($input_string, $methodID, "in"); # number of input parameters <parameter> <parameter> /scripts/script.sh <parameter>
	
	return $data_input_field_id;
}

function input_edit($id, $methodID, $name, $dataName, $typeCode, $regexpMatch, $allowNulls) {
	global $throwExceptionArray;
	
	//Input data validation 	
	if (empty($id) || $id == 0) {
	  	catchException($id,"id","input_edit","Id must not be empty or zero!");
    	return;
  	}
  	
	$data_input_fields = validateInputOutputFields($id, "input", $methodID, $name, $dataName,  "", $typeCode, $regexpMatch, $allowNulls);
	if ($throwExceptionArray){return;}
    
	//DataBase validation
	$typeID = db_fetch_cell("select type_id from data_input where id = " . $methodID);
	if (!$typeID) {
    	catchException($methodID,"methodID","input_edit","Not exists - id: " . $methodID);
    	return;
  	}
  	
	if ($typeID == 1){
		$substring = db_fetch_cell("select input_string from data_input where id = " . $methodID); 	//select script with input and output parameters
		$returnval = checkAvalibleInputOutputFields($substring);
		if (!isset($returnval)){
      		catchException($returnval,"returnval","input_edit","This script appears to have no input values, therefore there is nothing to add");
      		return;
   		}
	}
		
	/*$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'in' and id = '$id'");
	if(!isset($existAlready)){
	  $returnResult = throwException($id,"id","input_edit","Not exists - id: " . $id);
    return $returnResult;
  }*/

  //DataBase execute
	$data_input_field_id = sql_save($data_input_fields, "data_input_fields");
	
	db_execute("update data_input_fields set sequence=0 where data_input_id=" . $methodID);
	$input_string = db_fetch_cell("select input_string from data_input where id = '" . $methodID . "'");
	generate_data_input_field_sequences($input_string, $methodID, "in"); # number of input parameters <parameter> <parameter> /scripts/script.sh <parameter>
	
	return $data_input_field_id;
}

function input_delete($id) {
  	#php add_data_input.php --type input --do delete --ID 42
  
	//Input data validation
	if (empty($id) || $id == 0) {
		catchException($id,"id","input_delete","Id must not be empty or zero!");
    	return;
  	}	

	//Base validation
	$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'in' and id = '$id'");
	//$existAlready1 = db_fetch_cell("select id from data_input_data where data_input_field_id = '$id'");
  	if(!isset($existAlready)){
        catchException($id,"id","input_delete","Not exist - id: " . $id);
        return;
  	}
  	
  	//DataBase execute
  
	/* get information about the field we're going to delete so we can re-order the seqs */
	$field = db_fetch_row("select input_output,data_input_id from data_input_fields where id=" . $id);

	db_execute("delete from data_input_fields where id=" . $id);
	db_execute("delete from data_input_data where data_input_field_id=" . $id);
	
	global $registered_cacti_names;
	/* when a field is deleted; we need to re-order the field sequences */
	//$field["input_output"]=="in" &&
	if (preg_match_all("/<([_a-zA-Z0-9]+)>/", db_fetch_cell("select input_string from data_input where id=" . $field["data_input_id"]), $matches)) {
    	//if (preg_match_all("/<([_a-zA-Z0-9]+)>/", db_fetch_cell("select " . $field["input_output"] . "put_string from data_input where id=" . $field["data_input_id"]), $matches)){
    	$j = 0;
      	for ($i=0; ($i < count($matches[1])); $i++) {
      		if (in_array($matches[1][$i], $registered_cacti_names) == false) {
        		$j++;
        		db_execute("update data_input_fields set sequence=$j where data_input_id=" . $field["data_input_id"] . " and input_output='" .  $field["input_output"]. "' and data_name='" . $matches[1][$i] . "'");
      	  	}
    	}
	}

	return $id;
}

######################################################################################################
/*
 * For output
 */
function output_show($id,$methodID) {
	if(!empty($id) || $id != 0){
    	$wherequery = "where id = $id and input_output = 'out'";
  	}elseif(!empty($methodID) || $methodID != 0) {
    	$wherequery = "where data_input_id = $methodID and input_output = 'out'";
  	}else{
    	$wherequery = "where input_output = 'out'";
  	}
  	$returnResult = db_fetch_assoc("select id, name, data_input_id, data_name, update_rra from data_input_fields $wherequery order by id");
	return $returnResult;
}

function output_add($methodID, $name, $dataName,  $updateRRA) {
	global $throwExceptionArray;
	//Input data validation
	$data_input_fields = validateInputOutputFields(0, "output", $methodID, $name, $dataName,  $updateRRA, "", "", "");
	if ($throwExceptionArray){return;}
  
  	//DataBase validation
	$typeID = db_fetch_cell("select type_id from data_input where id = " . $methodID);
	if (!$typeID) {
	  	catchException($methodID,"methodID","output_add","Not exists - id: " . $methodID);
    	return;
  	}
	$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'out' and name = '$name'");
	if(isset($existAlready)){
	  	catchException($name,"name","output_add","Already Exists name: " . $name);
    	return;
  	}

	//DataBase execute
	$data_input_field_id = sql_save($data_input_fields, "data_input_fields");	//Save data to database
	
	//db_execute("update data_input_fields set sequence=0 where data_input_id=" . $methodID);
	//$input_string = db_fetch_cell("select input_string from data_input where id = '" . $methodID . "'");
	//generate_data_input_field_sequences($input_string, $methodID, "out"); # number of output parameters <parameter> <parameter> /scripts/script.sh <parameter> <parameter>
	
	return $data_input_field_id;
}

function output_edit($id, $methodID, $name, $dataName,  $updateRRA) {
	global $throwExceptionArray;
	# php add_data_input.php --type output --do edit --ID 46 --name OutputEDIT --methodID 16 --dataName EditName
  
	if (empty($id) || $id == 0) {
		catchException($id,"id","output_edit","Id must not be empty or zero!");
    	return;
  	}
		
	//Input data validation
	$data_input_fields = validateInputOutputFields($id, "output", $methodID, $name, $dataName,  $updateRRA, "", "", "");
	if ($throwExceptionArray){return;}
  
  	//DataBase validation
	$typeID = db_fetch_cell("select type_id from data_input where id = " . $methodID);
	if (!$typeID) {
		catchException($methodID,"methodID","output_add","Not Exists method: " . $methodID);
    	return;
  	}
	$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'out' and id = $id");
	if(!isset($existAlready)){
		catchException($id,"id","output_add","Not Exists id: " . $id);
    	return;
 	}

  	//DataBase execute
	$data_input_field_id = sql_save($data_input_fields, "data_input_fields");	//Save data to database
  	return $data_input_field_id;
}

function output_delete($id) {
  	//Input data validation
	if (empty($id) || $id == 0) {
		catchException($id,"id","output_delete","Id must not be empty or zero!");
    	return;
  	}
  
	//DataBase validation
  	$existAlready = db_fetch_cell("select id from data_input_fields where input_output = 'out' and id = $id");
	if(!isset($existAlready)){
		catchException($id,"id","output_delete","Not Exists id: " . $id);
    	return;
  	}
    
  	//DataBase execute
	db_execute("delete from data_input_fields where id=" . $id);
	db_execute("delete from data_input_data where data_input_field_id=" . $id);

  	return $id;
}

?>